#ifndef PUBLISHER_H
#define PUBLISHER_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/RosOutPort.h>
#include "Num.h"

using namespace RTC;

class Publisher
: public RTC::DataFlowComponentBase
{
    public:
        Publisher(RTC::Manager* manager);
        ~Publisher();

        virtual RTC::ReturnCode_t onInitialize();
        virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

    protected:
        // Declare the variable that we will write over the port.
        numbers::Num _num;
        // Next, declare the port itself. It needs to know the data type that
        // we will send over the port. We get this from the header file, Num.h,
        // generated by the message compiler.
        RosOutPort<numbers::Num> _numOut;
};

extern "C"
{
    void publisherInit(RTC::Manager* manager);
};

#endif // PUBLISHER_H

