#ifndef SUBSCRIBER_H
#define SUBSCRIBER_H

#include <rtm/Manager.h>
#include <rtm/DataFlowComponentBase.h>
#include <rtm/RosInPort.h>
#include "Num.h"

using namespace RTC;

class Subscriber
    : public RTC::DataFlowComponentBase
{
    public:
        Subscriber(RTC::Manager* manager);
        ~Subscriber();

        virtual RTC::ReturnCode_t onInitialize();
        virtual RTC::ReturnCode_t onExecute(RTC::UniqueId ec_id);

    protected:
        // Declare the variable that we receive data from the port into.
        numbers::Num _num;
        // Next, declare the port itself. It needs to know the data type that
        // we will receive over the port. We get this from the header file,
        // Num.h, generated by the message compiler.
        RosInPort<numbers::Num> _numIn;
};

extern "C"
{
    void subscriberInit(RTC::Manager* manager);
};

#endif // SUBSCRIBER_H

